<?php
/**
* @copyright Copyright (C) 2006 - 2010 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
* @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
**/
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' );

class plgAnalyticsUser1 extends JPlugin
{
	function plgAnalyticsUser1( &$subject, $params )
	{
		parent::__construct( $subject, $params );
	}
	
	function onGetChartTypes(&$data, $name) {
		
		if($name != 'user1') return;
		
		$data = array('amcolumn');
	}

	function onDrawChart(&$objChart, $name, &$params)
	{
		if($name != 'user1') return;

		global $mainframe;

    	if( !JComponentHelper::isEnabled('com_users', true) ) {
			$errors = '<h3>User Component Not Exists or Not Enabled<h3>';
			return;
		}

		$mparams = JComponentHelper::getParams('com_analytics');

		$objChart->setConfig('width',$mparams->get('width', 770));
		$objChart->setConfig('height',$params->get('height', 400));
		$objChart->setConfig('background.alpha',"1");
		$objChart->setConfig('preloader_color',"#999999");
		$objChart->setConfig('column.type',"stacked");
		$objChart->setConfig('column.data_labels',"<![CDATA[{value}]]> ");
		$objChart->setConfig('column.data_labels_position',"inside");
		$objChart->setConfig('column.alpha',"60");
		$objChart->setConfig('depth',"5");
		$objChart->setConfig('angle',"25");
		$objChart->addLabel("<![CDATA[This graph shows user registration progress]]>",20 ,385 , array('text_size' => 10));
		$objChart->addLabel("<![CDATA[<b>User Registration Progress</b>]]>",15 ,25 , array('text_size' => 16));
	}
	
	function onGetForm(&$form, $name, $report, $params) 
	{
		if( $name != 'user1' ) return;
		
		$report_params = new JParameter($report->params, JPATH_ROOT.DS.'plugins'.DS.'analytics'.DS.$params->get('type').'.xml');
		
		$group = 'Advanced params';
		
		if (!isset($report_params->_xml[$group])) {
			return false;
		}
		
		$elements= $report_params->renderToArray('params', $group);
		
		$doc = &JFactory::getDocument();
		$doc->addStyleDeclaration('
			.label {
				text-align: right;
				height: 30px;
			}
			.field select {
				width: 13em;
			}
		');
		
		$form .= '<table cellspacing="2" cellpadding="2">';

		if ($description = $report_params->_xml[$group]->attributes('description')) {
			// add the params description to the display
			$desc  = JText::_($description);
			$form .= '<tr><td class="paramlist_description" colspan="2">'.$desc.'</td></tr>';
		}
		

		foreach ($elements as $key => $element)
		{
			$form .= '<tr>';

			if ($element[0]) {
				$form .= '<td class="label"><span class="editlinktip">'.$element[0].'</span></td>';
				$form .= '<td  class="inputbox field">'.$element[1].'</td>';
			} else {
				$form .= '<td  class="inputbox field" colspan="2">'.$element[1].'</td>';
			}

			$form .= '</tr>';
		}

		if (count($element) < 1) {
			$form .= "<tr><td colspan=\"2\"><i>".JText::_('There are no Parameters for this item')."</i></td></tr>";
		}

		$form .= '</table>';

	}

	function onChartData(&$objChart, $name, $params)
	{
		if( $name != 'user1' ) return;

		$db = JFactory::getDBO();
		$user = JFactory::getUser();
		$user_id = $params->get('user_id');

		$from = $params->get( 'start',  strftime( '%Y-%m-%d 00:00:00', mktime( 0, 0, 0, date( 'm' ) - 1, date( 'd' ), date( 'Y' ) ) ) );
		$to   = $params->get( 'finish', strftime( '%Y-%m-%d 00:00:00', mktime( 23, 59, 59, date( 'm' ), date( 'd' ), date( 'Y' ) ) ) );

		$from = strftime( '%Y-%m-%d 00:00:00', strtotime( $from ) );
		$to   = strftime( '%Y-%m-%d 00:00:00', strtotime( $to ) );

		$groupby = $params->get( 'groupby', 'sday' );

		switch ( $groupby ) {
			case "sday":
				$format_description = '%Y %d %b';
				$format_series      = '%Y %d %b';
				$format_indexes     = '%Y %d %b';
				break;
			case "sweek":
				$format_description = '%Y %U Week';
				$format_series      = '%Y %UW';
				$format_indexes     = '%Y %U';
				break;
			case "smonth":
				$format_description = '%Y %b';
				$format_series      = '%Y %b';
				$format_indexes     = '%Y %b';
				break;
		}

		$sql = "
		SELECT COUNT( u.id )                                    AS total,
		DATE_FORMAT( u.registerDate, '%Y, %m, %d' )      AS sday,
		DATE_FORMAT( u.registerDate, '%Y, %U' )          AS sweek,
		DATE_FORMAT( u.registerDate, '%Y, %m' )          AS smonth,
		DATE_FORMAT( u.registerDate, '$format_indexes' ) AS index_date
		FROM #__users AS u
		WHERE u.registerDate > '$from'
		AND u.registerDate < '$to'
		AND u.block = 1 ";
		if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
		$sql .= " AND u.id = '$user_id'";
		$sql .= "
		GROUP BY `{$groupby}`
		ORDER BY u.registerDate  ASC
            ";
		$db->setQuery($sql); 
		$bresult = $db->loadObjectList();

		foreach ( $bresult AS $key => $row ) {
			$bres[$row->index_date] = $row->total;
		}

		$sql = "
		SELECT COUNT( u.id )                                    AS total,
		DATE_FORMAT( u.registerDate, '%Y, %m, %d' )      AS sday,
		DATE_FORMAT( u.registerDate, '%Y, %U' )          AS sweek,
		DATE_FORMAT( u.registerDate, '%Y, %m' )          AS smonth,
		DATE_FORMAT( u.registerDate, '$format_indexes' ) AS index_date
		FROM #__users AS u
		WHERE u.registerDate > '$from'
		AND u.registerDate < '$to'
		AND u.block <> 1";
		if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
		$sql .= " AND u.id = '$user_id'";
		$sql .= "
		GROUP BY `{$groupby}`
		ORDER BY u.registerDate  ASC
            ";
		$db->setQuery($sql);
		$result = $db->loadObjectList();

		foreach ( $result AS $key => $row ) {
			$res[$row->index_date] = $row->total;
		}
		if( !$result && !$bresult) return;
		//if( !$bresult ) return;

		$date = $from;
		$key = 0;
		while( strtotime( $date ) <= strtotime( $to ) ) {
			$key ++;

			$index_date  = strftime( $format_indexes,     strtotime( $date ) );
			$serie       = strftime( $format_series,      strtotime( $date ) );
			$description = strftime( $format_description, strtotime( $date ) );

			if( isset( $res[$index_date] ) ) {
				$value = $res[$index_date];
			} else {
				$value = 0;
			}

			if( isset( $bres[$index_date] ) ) {
				$bvalue = $bres[$index_date];
			} else {
				$bvalue = 0;
			}

			$objChart->addSerie($key,$serie);
			
			$graph1[] = array('xid' => $key, 'description' => $description, 'value' => $value);
			$graph2[] = array('xid' => $key, 'description' => $description, 'value' => $bvalue);

			$date = $this->incrementDate( $date, $groupby );
		}

		
		$objChart->addGraph(1, JText::_( "Amount Of User Registered" ), $graph1, array( 
			'balloon_text' => '<![CDATA[<b>{value}</b> user(s) registered <b>{description}</b>]]>'
		));

		if($params->get('block') == 0)
		{
			
			$objChart->addGraph(2, JText::_( "Amount Of User Registered but not active" ), $graph2, array( 
    			'balloon_text' => '<![CDATA[<b>{value}</b> not active user(s) registered <b>{description}</b>]]>'
    		));
		}
	}

	function onDrawTable(&$table, $name, $params)
	{
		if($name != 'user1') return;

		$db = JFactory::getDBO();
		$user = JFactory::getUser();
		$user_id = $params->get('user_id');

		$from = $params->get( 'start',  strftime( '%Y-%m-%d 00:00:00', mktime( 0, 0, 0, date( 'm' ) - 1, date( 'd' ), date( 'Y' ) ) ) );
		$to   = $params->get( 'finish', strftime( '%Y-%m-%d 00:00:00', mktime( 23, 59, 59, date( 'm' ), date( 'd' ), date( 'Y' ) ) ) );

		$from = strftime( '%Y-%m-%d 00:00:00', strtotime( $from ) );
		$to   = strftime( '%Y-%m-%d 00:00:00', strtotime( $to ) );

		$groupby = $params->get( 'groupby', 'sday' );
		$sort_by = $params->get('sort_by');
		$limit = $params->get('limit', 0);

		switch ( $groupby ) {
			case "sday":
				$format_indexes     = '%Y %d %b';
				break;
			case "sweek":
				$format_indexes     = '%Y %U Week';
				break;
			case "smonth":
				$format_indexes     = '%Y %b';
				break;
		}

		$sql = "
		SELECT COUNT( u.id ) AS total,
		DATE_FORMAT( u.registerDate, '%Y, %m, %d' )      AS sday,
		DATE_FORMAT( u.registerDate, '%Y, %U' )          AS sweek,
		DATE_FORMAT( u.registerDate, '%Y, %m' )          AS smonth,
		DATE_FORMAT( u.registerDate, '$format_indexes' ) AS index_date
		FROM #__users AS u
		WHERE u.registerDate > '$from'
		AND u.registerDate < '$to'".
		( $params->get( 'block', 0 ) == 0 ?  "" : " AND u.block = 0 " );
		if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
		$sql .= " AND u.id = '$user_id'";
		$sql .= "
		GROUP BY `$groupby`
		ORDER BY  ".($sort_by ? $sort_by : 'u.registerDate  ASC');
		if($limit)
		$sql .= " LIMIT 0, $limit";

		$db->setQuery($sql);
		$result = $db->loadObjectList();

		if(!$result) return;

		$k = 0;
		$total = 0;

		$out[] = '<table class="adminlist" cellspacing="0">';
		$out[] = '<thead>';
		$out[] = '<tr>';
		$out[] = '<th width="1%">#</th>';
		$out[] = '<th class="title">'.JText::_('Date').'</th>';
		$out[] = '<th width="1%">'.JText::_('Total').'</th>';
		$out[] = '</tr>';
		$out[] = '</thead>';
		$out[] = '<tbody>';

		foreach ( $result AS $var => $row ) {
			$k = 1 - $k;
			$out[] = "<tr class='row".$k."'><td>".( $var + 1 )."</td><td nowrap>".$row->index_date."</td><td>".$row->total."</td></tr>";
			$total += $row->total;
		}

		$out[] = '<tr><td colspan="2" align="right"><b>'.JText::_('Total').'</b></td><td><b><big>'.$total.'</big></b></td></tr></tbody></table>';

		$table = implode( "", $out );

		if( $params->get( 'rep_xls' ) )
		{
			jimport('joomla.filesystem.file');
			$file = JPATH_ROOT.DS.'cache'.DS.$user->id.DS.$name.'.xls';
			JFile::write($file, $table);
		}
	}

	function onGetTotals($name, $params)
	{
		if($name != 'user1') return;
		
		$db = JFactory::getDBO();
		$user = JFactory::getUser();
		$user_id = $params->get('user_id');

		$db = JFactory::getDBO();

		$from = $params->get('start', date('Y-m-d H:s:i', mktime(0,0,0, date('m')-1, date('d'), date('Y'))));
		$to = $params->get('finish', date('Y-m-d H:s:i', mktime(23,59,59, date('m'), date('d'), date('Y'))));

		$totals = array();
		
		$sql = "
		SELECT COUNT( u.id ) AS total, block
		FROM #__users AS u
		WHERE 1 ".
		( $params->get( 'block', 0 ) == 0 ?  "" : " AND u.block = 0 " );
		if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
		$sql .= " AND u.id = '$user_id'";
		$sql .= " GROUP BY u.block
		ORDER by u.block";  				
		$db->setQuery( $sql );
		$dbtotals = $db->loadObjectList();
		
		$sql = "
		SELECT COUNT( u.id ) AS total, block
		FROM #__users AS u
		WHERE u.registerDate > '$from'
		AND u.registerDate < '$to'".
		( $params->get( 'block', 0 ) == 0 ?  "" : " AND u.block = 0 " );
		if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
		$sql .= " AND u.id = '$user_id'";
		$sql .= " GROUP BY u.block
		ORDER by u.block";  				
		$db->setQuery( $sql );
		
		$result = $db->loadObjectList();
		if( !$dbtotals && !$result ) return;
		$all = 0;
		$cur_blocked = 0;
		$cur_activated = 0;
		$blocked = 0;
		foreach ($dbtotals as $total) {
			$all += $total->total;
			($total->block == 1) ? $blocked = $total->total : $activated = $total->total;
		}
		
		foreach($result as $val)
		{
			($val->block == 1) ? $cur_blocked = $val->total : $cur_activated = $val->total;
		}

		$totals[0]['value'] = $params->get( 'block', 0 ) == 0 ?  $all : $all = $activated ;
		$totals[0]['text'] = JText::_( 'Total Users in DB');
		
		$totals[2]['value'] = $cur_activated;
		$totals[2]['text'] = JText::_( 'Total users in this report ').'('. round(($cur_activated + $cur_blocked) * 100 / $all, 1).'% '.JText::_('of total').')';
		
		if( $params->get( 'block', 0 ) == 0 ) {
			$totals[1]['value'] = $blocked;
			$totals[1]['text'] = JText::_( 'Total inactive users in DB ').'('. round($blocked * 100 / $all, 1).'% '.JText::_('of total').')';
			
			$totals[3]['value'] = $cur_blocked;
			$totals[3]['text'] = JText::_( ' Total inactive users of this report ').'('. ( $blocked!=0 ? round($cur_blocked * 100 / $blocked, 1) : 0 ).'% '.JText::_('of blocked').')';
		}
		
		ksort($totals);
		
		return $totals;
	}

	function incrementDate( $date, $unit )
	{
		$eDate = getDate( strtotime( $date ) );

		switch ( $unit ) {
			case "sday":
				$eDate["mday"] ++;
				break;
			case "sweek":
				$eDate["mday"] += 7;
				break;
			case "smonth":
				$eDate["mon"] ++;
				break;
		}

		return  date( 'Y-m-d H:s:i', mktime( $eDate["hours"], $eDate["minutes"], $eDate["seconds"], $eDate["mon"], $eDate["mday"], $eDate["year"] ) );
	}
}
?>