<?php
/**
* @copyright Copyright (C) 2006 - 2010 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
* @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
**/
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' );

class plgAnalyticsUser2 extends JPlugin
{
	function plgAnalyticsUser2( &$subject, $params )
	{
		parent::__construct( $subject, $params );
	}
	
	function onGetChartTypes(&$data, $name) {
		
		if($name != 'user2') return;
		
		$data = array('ampie');
	}

	function onDrawChart(&$objChart, $name, &$params)
	{
		if( $name != 'user2' ) return;
		global $mainframe;

    	if( !JComponentHelper::isEnabled('com_users', true) ) {
			$errors = '<h3>User Component Not Exists or Not Enabled<h3>';
			return;
		}

		$mparams = JComponentHelper::getParams('com_analytics');

		$objChart->setConfig('width',$mparams->get('width', 770));
		$objChart->setConfig('height',$params->get('height', 400));
		$objChart->setConfig('background.alpha',"1");
		$objChart->setConfig('preloader_color',"#999999");
		$objChart->setConfig('data_labels',"<![CDATA[{title}: {value} (<b>{percents}%</b>)]]> ");
		$objChart->setConfig('balloon.show',"<![CDATA[{title}: {value} User which is (<b>{percents}%</b>)]]>");
		$objChart->addLabel("<![CDATA[This graoh show last activity of each user on your site]]>",20 ,385 , array('text_size' => 10));
		$objChart->addLabel("<![CDATA[<b>User Last Activity</b>]]>",15 ,25 , array('text_size' => 16));
	}
	
	function onGetForm(&$form, $name, $report, $params) 
	{
		if( $name != 'user2' ) return;
		
		$report_params = new JParameter($report->params, JPATH_ROOT.DS.'plugins'.DS.'analytics'.DS.$params->get('type').'.xml');
		
		$group = 'Advanced params';
		
		if (!isset($report_params->_xml[$group])) {
			return false;
		}
		
		$elements= $report_params->renderToArray('params', $group);
		
		$doc = &JFactory::getDocument();
		$doc->addStyleDeclaration('
			.label {
				text-align: right;
				height: 30px;
			}
			.field select {
				width: 13em;
			}
		');
		
		$form .= '<table cellspacing="2" cellpadding="2">';

		if ($description = $report_params->_xml[$group]->attributes('description')) {
			// add the params description to the display
			$desc  = JText::_($description);
			$form .= '<tr><td class="paramlist_description" colspan="2">'.$desc.'</td></tr>';
		}
		

		foreach ($elements as $key => $element)
		{
			$form .= '<tr>';

			if ($element[0]) {
				$form .= '<td class="label"><span class="editlinktip">'.$element[0].'</span></td>';
				$form .= '<td  class="inputbox field">'.$element[1].'</td>';
			} else {
				$form .= '<td  class="inputbox field" colspan="2">'.$element[1].'</td>';
			}

			$form .= '</tr>';
		}

		if (count($element) < 1) {
			$form .= "<tr><td colspan=\"2\"><i>".JText::_('There are no Parameters for this item')."</i></td></tr>";
		}

		$form .= '</table>';

	}

	function onChartData(&$objChart, $name, $params)
	{
		if( $name != 'user2' ) return;
			
		$db = JFactory::getDBO();
		$user = JFactory::getUser();
		$user_id = $params->get('user_id');

		$from = $params->get( 'start',  strftime( '%Y-%m-%d 00:00:00', mktime( 0, 0, 0, date( 'm' ) - 1, date( 'd' ), date( 'Y' ) ) ) );
		$to   = $params->get( 'finish', strftime( '%Y-%m-%d 00:00:00', mktime( 23, 59, 59, date( 'm' ), date( 'd' ), date( 'Y' ) ) ) );

		$from = strftime( '%Y-%m-%d 00:00:00', strtotime( $from ) );
		$to   = strftime( '%Y-%m-%d 00:00:00', strtotime( $to ) );

		$group = $params->get( 'groupby', 'sday' );

		switch ( $group ) {
			case "sday":
				$format_indexes = "CONCAT( CEILING( ( UNIX_TIMESTAMP( NOW() ) - UNIX_TIMESTAMP( lastvisitDate ) ) / 86400 ), ' ".JText::_( "Day ago" )."' )";
				break;
			case "sweek":
				$format_indexes = "CONCAT( CEILING( ( UNIX_TIMESTAMP( NOW() ) - UNIX_TIMESTAMP( lastvisitDate ) ) / ( 86400 * 7 ) ), ' ".JText::_( "Week ago" )."' )";
				break;
		}

		$sql = "  SELECT COUNT( id ) AS total, DATE_FORMAT( lastvisitDate, '%Y, %m, %d' ) AS sday,
		CONCAT( YEAR( lastvisitDate ),	' ', CEILING( ( UNIX_TIMESTAMP( NOW() ) - UNIX_TIMESTAMP( lastvisitDate ) ) / ( 86400 * 7 ) ) ) AS sweek,
		$format_indexes AS index_date
		FROM #__users
		WHERE lastvisitDate > '$from'
		AND lastvisitDate < '$to'
		AND block != 1";
		if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
		$sql .= " AND id = '$user_id'";
		$sql .= "
		GROUP BY `{$group}`
		ORDER BY lastvisitDate DESC ";

		$db->setQuery( $sql );
		$result = $db->loadObjectList();

		if( !$result ) return;

	    foreach ( $result AS $row ) {
			$slices[$row->index_date] = $row->total;
		}
		$k = true;
		foreach ( $slices AS $key => $slice ) {
			if( $k ) {
				$pulout = "pull_out='true'";
				$k = false;
			}
			$objChart->addSlice($key, $slice, array( 'pull_out' => $pulout, 'alpha' => 95) );
		}
	}

	function onDrawTable(&$table, $name, $params)
	{
		if($name != 'user2') return;

		$db = JFactory::getDBO();
		$user = JFactory::getUser();
		$user_id = $params->get('user_id');

		$from = $params->get( 'start',  strftime( '%Y-%m-%d 00:00:00', mktime( 0, 0, 0, date( 'm' ) - 1, date( 'd' ), date( 'Y' ) ) ) );
		$to   = $params->get( 'finish', strftime( '%Y-%m-%d 00:00:00', mktime( 23, 59, 59, date( 'm' ), date( 'd' ), date( 'Y' ) ) ) );

		$from = strftime( '%Y-%m-%d 00:00:00', strtotime( $from ) );
		$to   = strftime( '%Y-%m-%d 00:00:00', strtotime( $to ) );

		$group = $params->get( 'groupby', 'sday' );
		$sort_by = $params->get('sort_by');
		$limit = $params->get('limit', 0);

		switch ( $group ) {
			case "sday":
				$format_indexes = "CONCAT( CEILING( ( UNIX_TIMESTAMP( NOW() ) - UNIX_TIMESTAMP( lastvisitDate ) ) / 86400 ), ' ".JText::_( "Day ago" )."' )";
				break;
			case "sweek":
				$format_indexes = "CONCAT( CEILING( ( UNIX_TIMESTAMP( NOW() ) - UNIX_TIMESTAMP( lastvisitDate ) ) / ( 86400 * 7 ) ), ' ".JText::_( "Week ago" )."' )";
				break;
		}

		$sql = "  SELECT COUNT( id ) AS total,
		DATE_FORMAT( lastvisitDate, '%Y, %m, %d' ) AS sday,
		CONCAT( YEAR( lastvisitDate ), ' ', CEILING( ( UNIX_TIMESTAMP( NOW() ) - UNIX_TIMESTAMP( lastvisitDate ) ) / ( 86400 * 7 ) ) ) AS sweek,
		$format_indexes AS index_date
		FROM #__users
		WHERE lastvisitDate > '$from'
		AND lastvisitDate < '$to'
		AND block != 1";
		if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
		$sql .= " AND id = '$user_id'";
		$sql .= "
		GROUP BY `{$group}`
		ORDER BY ".($sort_by ? $sort_by : 'lastvisitDate DESC');
		if($limit)
		$sql .= " LIMIT 0, $limit";

		$db->setQuery( $sql );
		$result = $db->loadObjectList();

		if( !$result ) return;

		$out[] = '<table class="adminlist" cellspacing="0">';
		$out[] = '<thead>';
		$out[] = '<tr>';
		$out[] = '<th width="1%">#</th>';
		$out[] = '<th class="title">'.JText::_('Period').'</th>';
		$out[] = '<th width="1%">'.JText::_('Total').'</th>';
		$out[] = '</tr>';
		$out[] = '</thead>';
		$out[] = '<tbody>';

		$k = 0;
		$r = 0;
		$total = 0;

		foreach ( $result AS $p => $row ) {
			$out[] = "<tr class='row".$k."'><td>".( $p + 1 )."</td><td nowrap>".$row->index_date."</td><td align='right'>".$row->total."</td></tr>";
			$total += $row->total;
		}

		$out[] = '<tr><td colspan="2" align="right"><b>'.JText::_( 'Total' ).'</b></td><td><b><big>'.$total.'</big></b></td></tr></tbody></table>';

		$table = implode( "", $out );

		if( $params->get( 'rep_xls' ) )
		{
			jimport('joomla.filesystem.file');
			$file = JPATH_ROOT.DS.'cache'.DS.$user->id.DS.$name.'.xls';
			JFile::write($file, $table);
		}
	}

	function onGetTotals($name, $params)
	{
		if($name != 'user2') return;
		
		$db = JFactory::getDBO();
		$user = JFactory::getUser();
		$user_id = $params->get('user_id');

		$from = $params->get('start', date('Y-m-d H:s:i', mktime(0,0,0, date('m')-1, date('d'), date('Y'))));
		$to = $params->get('finish', date('Y-m-d H:s:i', mktime(23,59,59, date('m'), date('d'), date('Y'))));

		$groupby = $params->get('groupby', 'sday');

		if($params->get('bill'))
		{
			if(is_array($params->get('bill'))){
				$ids = implode(", ", $params->get('bill'));
			} else {
				$ids = $params->get('bill');
			}
		}
		else
		{
			$ids = false;
		}

		$totals = array();

		switch ( $groupby ) {
			case "sday":
				$format_indexes = "CONCAT( CEILING( ( UNIX_TIMESTAMP( NOW() ) - UNIX_TIMESTAMP( lastvisitDate ) ) / 86400 ), ' ".JText::_( "Day ago" )."' )";
				break;
			case "sweek":
				$format_indexes = "CONCAT( CEILING( ( UNIX_TIMESTAMP( NOW() ) - UNIX_TIMESTAMP( lastvisitDate ) ) / ( 86400 * 7 ) ), ' ".JText::_( "Week ago" )."' )";
				break;
		}

		$sql = "  SELECT COUNT( id ) AS total
		FROM #__users
		WHERE lastvisitDate > '$from'
		AND lastvisitDate < '$to'
		AND block != 1";
		if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
		$sql .= " AND id = '$user_id'";		
		
		$db->setQuery( $sql );
		if($res = $db->loadResult())
		{			
			$totals[0]['value'] = $res;
			$totals[0]['text'] = JText::_( 'Total users amount logged in');
		}
		return $totals;
	}
}
?>